package edu.ucsc.its.temerity.buildlogic.convention

import com.diffplug.gradle.spotless.SpotlessExtension
import org.gradle.api.Plugin
import org.gradle.api.Project

class FormattingConventionPlugin : Plugin<Project> {
  override fun apply(project: Project) = with(project) {
    pluginManager.apply("com.diffplug.spotless")
    extensions.configure(SpotlessExtension::class.java) {
      kotlin {
        target("**/*.kt")
        targetExclude("${layout.buildDirectory}/**/*.kt")
        ktlint("1.5.0").editorConfigOverride(
          mapOf(
            "indent_size" to "2",
            "continuation_indent_size" to "2",
          ),
        )
        licenseHeaderFile(file("../spotless/LicenseHeader.kt"))
        trimTrailingWhitespace()
        endWithNewline()
      }
      format("kts") {
        target("**/*.kts")
        targetExclude("${layout.buildDirectory}/**/*.kts")
        licenseHeaderFile(file("../spotless/LicenseHeader.kt"), "(^(?![\\/ ]\\*).*$)")
        trimTrailingWhitespace()
        endWithNewline()
      }
    }
  }
}
