/*
 *     Designed and developed in 2022-2024 by William Walker (wnwalker@ucsc.edu)
 *     Copyright 2022-2024 The Regents of the University of California. All rights reserved.
 *
 *     This library is free software; you can redistribute it and/or
 *     modify it under the terms of the GNU Lesser General Public
 *     License as published by the Free Software Foundation; version 2.1 of the License.
 *
 *     This library is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *     Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public
 *     License along with this library; if not, write to the Free Software
 *     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package edu.ucsc.its.temerity.buildlogic.convention

import org.danilopianini.gradle.gitsemver.GitSemVerExtension
import org.gradle.api.Plugin
import org.gradle.api.Project

class VersionConventionPlugin : Plugin<Project> {
  override fun apply(project: Project) = with(project) {
    pluginManager.apply("org.danilopianini.git-sensitive-semantic-versioning")
    extensions.configure(GitSemVerExtension::class.java) {
      maxVersionLength.set(20)
    }
  }
}
